# Convert binary file to a hex encoded array for inclusion in C projects

def convert(filename):
	i = open(filename, 'rb')
	data = i.read()
	i.close()
	
	filename = filename[:-4]
	
	if len(data) % 4:
		data += (chr(0)*(4 - (len(data) % 4))).encode()
	
	h = open(filename+'.h', 'w')
	h.write('extern const unsigned int %s[%i];\n' % (filename, len(data)//4))
	h.close()
	
	c = open(filename+'.c', 'w')
	c.write('const unsigned int %s[%i] = \n{\n' % (filename, len(data)//4))
		
	for i in range(len(data) // 4):
		c.write('	0x')
		for j in range(4):
			c.write('%02x' % ord(data[4*i + 3 - j]))
		c.write(',\n')
	
	c.write('};\n')
	c.close()

if __name__ == "__main__":
	import sys
	if len(sys.argv) == 2:
		convert(sys.argv[1])
	else:
		print('usage : %s filename' % argv[0])