#ifndef AVATAR_HPP_INCLUDED
#define AVATAR_HPP_INCLUDED

#include "util.hpp"
#include "level.hpp"
#include "entity.hpp"

extern const s8 jump_start[];
extern const s8 bumper_jump_start[];
extern const s8 pop_jump_start[];

class Avatar : public Entity
{
#ifdef SENTINELS
private: char __instanceBegin[4];
#endif

public:

	Avatar();
	//~Avatar() {}

	void init(u8 num, u8 width, u8 height);
	void update();
	void kill();

	bool isBumperBelow(u32 * bumperIndex=0);

	s8 jumpIndex;

	inline s8 jumpStart()
	{
		return jump_start[index];
	}

	inline s8 bumperJumpStart()
	{
		return bumper_jump_start[index];
	}

	inline s8 popJumpStart()
	{
		return pop_jump_start[index];
	}

#ifdef SENTINELS
private: char __instanceEnd[4];
#endif
};

#endif // AVATAR_HPP_INCLUDED


