#ifndef ENTITY_HPP_INCLUDED
#define ENTITY_HPP_INCLUDED

#include "util.hpp"
#include "level.hpp"

class Entity
{
#ifdef SENTINELS
private: char __entityInstanceBegin[4];
#endif

public:

	Entity();
	//~Entity() {}

	inline void setPositionTiles(s32 tx, s32 ty)
	{
		box.pos.x = tilesToPixels(tx);
		box.pos.y = tilesToPixels(ty);
	}

	inline void setPositionTiles(const Vector2i & tpos)
	{
		setPositionTiles(tpos.x, tpos.y);
	}

	void init(u8 num, u8 width, u8 height);
	Vector2i applyPhysics(Vector2i motion);
	bool isGroundBelow();

	Rect box; // Hitbox in pixels
	s8 dir; // X direction where the entity is looking (-1 or 1)
	u8 index; // Entity identifier (also for indexing in game arrays)
	bool active;
	u8 collisionMask;

#ifdef SENTINELS
	char __debug;
private:
	char __entityInstanceEnd[4];
#endif
};

#endif // ENTITY_HPP_INCLUDED



