#include "gba.h"
#include "main.h"
#include "sound.h"

void fade(u8 speed, bool black)
{
	*REG_BLDMOD = TOP_BG0 | TOP_BG1 | TOP_BG2 | TOP_BG3 | TOP_OBJ | TOP_BD | (black ? FX_BLACK : FX_WHITE);

	s16 fade = 0;

	while (fade < 256)
	{
		*REG_COLEY = fade / 8;

		do_frame = false;
		asm("swi 0x0002");

		if (do_frame)
		{
			update_sound();
			fade += speed;
		}
	}
}

void unfade(u8 speed, bool black)
{
	*REG_BLDMOD = TOP_BG0 | TOP_BG1 | TOP_BG2 | TOP_BG3 | TOP_OBJ | TOP_BD | (black ? FX_BLACK : FX_WHITE);

	s16 fade = 255;

	while (fade > 0)
	{
		*REG_COLEY = fade / 8;

		do_frame = false;
		asm("swi 0x0002");

		if (do_frame)
		{
			update_sound();
			fade -= speed;
		}
	}

	*REG_BLDMOD = 0;
}
