#include "gba.h"
#include "main.h"
#include "graphic.h"
#include "fx.h"

#include "../graphics/Title_screen.h"
#include "../graphics/press_start.h"

#define START_X 100
#define START_Y 120

s8 alpha = 0;
s8 dir = 1;

void init_menu()
{
	*REG_DISPCNT = BG2_ENABLE | MODE_3 | OBJ_ENABLE | OBJ_MAP_1D | FORCE_VBLANK;

	// copy tilesets
	*REG_DMA3SAD = Title_screenBitmap;
	*REG_DMA3DAD = _vram;
	*REG_DMA3CNT = DMA_ENABLE | DMA_IMMEDIATE | DMA_32 | sizeof(Title_screenBitmap)/sizeof(u32);

	*REG_DMA3SAD = press_startTiles;
	*REG_DMA3DAD = vram_spr(512*32); // skip 512 tiles
	*REG_DMA3CNT = DMA_ENABLE | DMA_IMMEDIATE | DMA_32 | sizeof(press_startTiles)/sizeof(u32);

	*REG_DMA3SAD = press_startPal;
	*REG_DMA3DAD = _obj_palette; // skip 512 tiles
	*REG_DMA3CNT = DMA_ENABLE | DMA_IMMEDIATE | DMA_16 | sizeof(press_startPal)/sizeof(u16);

	clear_oam();

	oam[0].attr0 = GFX_BLEND | SH_WIDE | CM_8BPP | START_Y;
	oam[0].attr1 = SIZE_32 | START_X;
	oam[0].attr2 = 512;

	oam[1].attr0 = GFX_BLEND | SH_WIDE | CM_8BPP | START_Y;
	oam[1].attr1 = SIZE_32 | START_X + 32;
	oam[1].attr2 = 512 + 16;

	oam[2].attr0 = GFX_BLEND | SH_WIDE | CM_8BPP | START_Y;
	oam[2].attr1 = SIZE_32 | START_X + 64;
	oam[2].attr2 = 512 + 32;

	oam[3].attr0 = GFX_BLEND | SH_WIDE | CM_8BPP | START_Y;
	oam[3].attr1 = SIZE_32 | START_X + 96;
	oam[3].attr2 = 512 + 48;

	*REG_DISPCNT &= ~FORCE_VBLANK;
}

void update_menu()
{
	// skip 3 frames
	if ((frame_counter & 3) == 0)
	{
		alpha += dir;
		if (alpha == -4)
		{
			dir = 1;
		}
		else if (alpha == 19)
		{
			dir = -1;
		}
	}

	s8 a = alpha;
	if (a < 0)
		a = 0;
	if (a > 16)
		a = 16;

	*REG_BLDMOD = TOP_OBJ | BOT_BG2 | FX_ALPHA;
	*REG_COLEVA = a;
	*REG_COLEVB = 0x10 - a;
}

void cleanup_menu()
{
	*REG_BLDMOD = 0;
}
